diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index 07860b4d4c..2a96996e42 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -164,8 +164,8 @@ main(int argc, char *argv[])
 					exit(1);
 				}
 				if (!TransactionIdIsNormal(set_oldest_xid))
-					pg_fatal("oldest transaction ID (-u) must be greater than or equal to %llu",
-							 (unsigned long long) FirstNormalTransactionId);
+					pg_fatal("oldest transaction ID (-u) must be greater than or equal to %" PRIu64,
+							 FirstNormalTransactionId);
 				break;
 
 			case 'x':
@@ -178,8 +178,8 @@ main(int argc, char *argv[])
 					exit(1);
 				}
 				if (!TransactionIdIsNormal(set_xid))
-					pg_fatal("transaction ID (-x) must be greater than or equal to %llu",
-							 (unsigned long long) FirstNormalTransactionId);
+					pg_fatal("transaction ID (-x) must be greater than or equal to %" PRIu64,
+							 FirstNormalTransactionId);
 				break;
 
 			case 'c':
@@ -201,15 +201,15 @@ main(int argc, char *argv[])
 
 				if (set_oldest_commit_ts_xid < FirstNormalTransactionId &&
 					set_oldest_commit_ts_xid != InvalidTransactionId)
-					pg_fatal("transaction ID (-c) must be either %llu or greater than or equal to %llu",
-							 (unsigned long long) InvalidTransactionId,
-							 (unsigned long long) FirstNormalTransactionId);
+					pg_fatal("transaction ID (-c) must be either %" PRIu64 " or greater than or equal to %" PRIu64,
+							 InvalidTransactionId,
+							 FirstNormalTransactionId);
 
 				if (set_newest_commit_ts_xid < FirstNormalTransactionId &&
 					set_newest_commit_ts_xid != InvalidTransactionId)
-					pg_fatal("transaction ID (-c) must be either %llu or greater than or equal to %llu",
-							 (unsigned long long) InvalidTransactionId,
-							 (unsigned long long) FirstNormalTransactionId);
+					pg_fatal("transaction ID (-c) must be either %" PRIu64 " or greater than or equal to %" PRIu64,
+							 InvalidTransactionId,
+							 FirstNormalTransactionId);
 				break;
 
 			case 'o':
@@ -736,28 +736,28 @@ PrintControlValues(bool guessed)
 		   ControlFile.checkPointCopy.ThisTimeLineID);
 	printf(_("Latest checkpoint's full_page_writes: %s\n"),
 		   ControlFile.checkPointCopy.fullPageWrites ? _("on") : _("off"));
-	printf(_("Latest checkpoint's NextXID:          %llu\n"),
-		   (unsigned long long) XidFromFullTransactionId(ControlFile.checkPointCopy.nextXid));
+	printf(_("Latest checkpoint's NextXID:          %" PRIu64 "\n"),
+		   XidFromFullTransactionId(ControlFile.checkPointCopy.nextXid));
 	printf(_("Latest checkpoint's NextOID:          %u\n"),
 		   ControlFile.checkPointCopy.nextOid);
-	printf(_("Latest checkpoint's NextMultiXactId:  %llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.nextMulti);
-	printf(_("Latest checkpoint's NextMultiOffset:  %llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.nextMultiOffset);
-	printf(_("Latest checkpoint's oldestXID:        %llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.oldestXid);
+	printf(_("Latest checkpoint's NextMultiXactId:  %" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.nextMulti);
+	printf(_("Latest checkpoint's NextMultiOffset:  %" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.nextMultiOffset);
+	printf(_("Latest checkpoint's oldestXID:        %" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.oldestXid);
 	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
 		   ControlFile.checkPointCopy.oldestXidDB);
-	printf(_("Latest checkpoint's oldestActiveXID:  %llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.oldestActiveXid);
-	printf(_("Latest checkpoint's oldestMultiXid:   %llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.oldestMulti);
+	printf(_("Latest checkpoint's oldestActiveXID:  %" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.oldestActiveXid);
+	printf(_("Latest checkpoint's oldestMultiXid:   %" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.oldestMulti);
 	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
 		   ControlFile.checkPointCopy.oldestMultiDB);
-	printf(_("Latest checkpoint's oldestCommitTsXid:%llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.oldestCommitTsXid);
-	printf(_("Latest checkpoint's newestCommitTsXid:%llu\n"),
-		   (unsigned long long) ControlFile.checkPointCopy.newestCommitTsXid);
+	printf(_("Latest checkpoint's oldestCommitTsXid:%" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.oldestCommitTsXid);
+	printf(_("Latest checkpoint's newestCommitTsXid:%" PRIu64 "\n"),
+		   ControlFile.checkPointCopy.newestCommitTsXid);
 	printf(_("Maximum data alignment:               %u\n"),
 		   ControlFile.maxAlign);
 	/* we don't print floatFormat since can't say much useful about it */
@@ -806,18 +806,18 @@ PrintNewControlValues(void)
 
 	if (set_mxid != 0)
 	{
-		printf(_("NextMultiXactId:                      %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.nextMulti);
-		printf(_("OldestMultiXid:                       %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.oldestMulti);
+		printf(_("NextMultiXactId:                      %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.nextMulti);
+		printf(_("OldestMultiXid:                       %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.oldestMulti);
 		printf(_("OldestMulti's DB:                     %u\n"),
 			   ControlFile.checkPointCopy.oldestMultiDB);
 	}
 
 	if (set_mxoff != -1)
 	{
-		printf(_("NextMultiOffset:                      %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.nextMultiOffset);
+		printf(_("NextMultiOffset:                      %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.nextMultiOffset);
 	}
 
 	if (set_oid != 0)
@@ -828,23 +828,23 @@ PrintNewControlValues(void)
 
 	if (set_xid != 0)
 	{
-		printf(_("NextXID:                              %llu\n"),
-			   (unsigned long long) XidFromFullTransactionId(ControlFile.checkPointCopy.nextXid));
-		printf(_("OldestXID:                            %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.oldestXid);
+		printf(_("NextXID:                              %" PRIu64 "\n"),
+			   XidFromFullTransactionId(ControlFile.checkPointCopy.nextXid));
+		printf(_("OldestXID:                            %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.oldestXid);
 		printf(_("OldestXID's DB:                       %u\n"),
 			   ControlFile.checkPointCopy.oldestXidDB);
 	}
 
 	if (set_oldest_commit_ts_xid != 0)
 	{
-		printf(_("oldestCommitTsXid:                    %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.oldestCommitTsXid);
+		printf(_("oldestCommitTsXid:                    %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.oldestCommitTsXid);
 	}
 	if (set_newest_commit_ts_xid != 0)
 	{
-		printf(_("newestCommitTsXid:                    %llu\n"),
-			   (unsigned long long) ControlFile.checkPointCopy.newestCommitTsXid);
+		printf(_("newestCommitTsXid:                    %" PRIu64 "\n"),
+			   ControlFile.checkPointCopy.newestCommitTsXid);
 	}
 
 	if (set_wal_segsize != 0)
diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
index 72eda869a2..b681cbf0bb 100644
--- a/src/bin/pg_upgrade/pg_upgrade.c
+++ b/src/bin/pg_upgrade/pg_upgrade.c
@@ -798,17 +798,16 @@ copy_xact_xlog_xid(void)
 
 	prep_status("Setting oldest XID for new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -u %llu \"%s\"",
-			  new_cluster.bindir,
-			  (unsigned long long) old_cluster.controldata.chkpnt_oldstxid,
+			  "\"%s/pg_resetwal\" -f -u %" PRIu64 " \"%s\"",
+			  new_cluster.bindir, old_cluster.controldata.chkpnt_oldstxid,
 			  new_cluster.pgdata);
 	check_ok();
 
 	/* set the next transaction id and epoch of the new cluster */
 	prep_status("Setting next transaction ID and epoch for new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -x %llu \"%s\"",
-			  new_cluster.bindir, (unsigned long long) next_xid,
+			  "\"%s/pg_resetwal\" -f -x %" PRIu64 " \"%s\"",
+			  new_cluster.bindir, next_xid,
 			  new_cluster.pgdata);
 #ifdef NOT_USED
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
@@ -818,11 +817,8 @@ copy_xact_xlog_xid(void)
 #endif
 	/* must reset commit timestamp limits also */
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -c %llu,%llu \"%s\"",
-			  new_cluster.bindir,
-			  (unsigned long long) next_xid,
-			  (unsigned long long) next_xid,
-			  new_cluster.pgdata);
+			  "\"%s/pg_resetwal\" -f -c %" PRIu64 ",%" PRIu64 " \"%s\"",
+			  new_cluster.bindir, next_xid, next_xid, new_cluster.pgdata);
 	check_ok();
 
 	/*
@@ -884,11 +880,11 @@ copy_xact_xlog_xid(void)
 		 * counters here and the oldest multi present on system.
 		 */
 		exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-				  "\"%s/pg_resetwal\" -O %llu -m %llu,%llu \"%s\"",
+				  "\"%s/pg_resetwal\" -O %" PRIu64 " -m %" PRIu64 ",%" PRIu64 " \"%s\"",
 				  new_cluster.bindir,
-				  (unsigned long long) next_mxoff,
-				  (unsigned long long) next_mxid,
-				  (unsigned long long) oldest_mxid,
+				  next_mxoff,
+				  next_mxid,
+				  oldest_mxid,
 				  new_cluster.pgdata);
 		check_ok();
 	}
@@ -912,10 +908,10 @@ copy_xact_xlog_xid(void)
 		 * next=MaxMultiXactId, but multixact.c can cope with that just fine.
 		 */
 		exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-				  "\"%s/pg_resetwal\" -m %llu,%llu \"%s\"",
+				  "\"%s/pg_resetwal\" -m %" PRIu64 ",%" PRIu64 " \"%s\"",
 				  new_cluster.bindir,
-				  (unsigned long long) old_cluster.controldata.chkpnt_nxtmulti + 1,
-				  (unsigned long long) old_cluster.controldata.chkpnt_nxtmulti,
+				  old_cluster.controldata.chkpnt_nxtmulti + 1,
+				  old_cluster.controldata.chkpnt_nxtmulti,
 				  new_cluster.pgdata);
 		check_ok();
 	}
@@ -984,14 +980,14 @@ set_frozenxids(bool minmxid_only)
 		/* set pg_database.datfrozenxid */
 		PQclear(executeQueryOrDie(conn_template1,
 								  "UPDATE pg_catalog.pg_database "
-								  "SET	datfrozenxid = '%llu'",
-								  (unsigned long long) frozen_xid));
+								  "SET	datfrozenxid = '%" PRIu64 "'",
+								  frozen_xid));
 
 	/* set pg_database.datminmxid */
 	PQclear(executeQueryOrDie(conn_template1,
 							  "UPDATE pg_catalog.pg_database "
-							  "SET	datminmxid = '%llu'",
-							  (unsigned long long) minmxid));
+							  "SET	datminmxid = '%" PRIu64 "'",
+							  minmxid));
 
 	/* get database names */
 	dbres = executeQueryOrDie(conn_template1,
@@ -1025,24 +1021,24 @@ set_frozenxids(bool minmxid_only)
 			/* set pg_class.relfrozenxid */
 			PQclear(executeQueryOrDie(conn,
 									  "UPDATE	pg_catalog.pg_class "
-									  "SET	relfrozenxid = '%llu' "
+									  "SET	relfrozenxid = '%" PRIu64 "' "
 			/* only heap, materialized view, and TOAST are vacuumed */
 									  "WHERE	relkind IN ("
 									  CppAsString2(RELKIND_RELATION) ", "
 									  CppAsString2(RELKIND_MATVIEW) ", "
 									  CppAsString2(RELKIND_TOASTVALUE) ")",
-									  (unsigned long long) frozen_xid));
+									  frozen_xid));
 
 		/* set pg_class.relminmxid */
 		PQclear(executeQueryOrDie(conn,
 								  "UPDATE	pg_catalog.pg_class "
-								  "SET	relminmxid = '%llu' "
+								  "SET	relminmxid = '%" PRIu64 "' "
 		/* only heap, materialized view, and TOAST are vacuumed */
 								  "WHERE	relkind IN ("
 								  CppAsString2(RELKIND_RELATION) ", "
 								  CppAsString2(RELKIND_MATVIEW) ", "
 								  CppAsString2(RELKIND_TOASTVALUE) ")",
-								  (unsigned long long) minmxid));
+								  minmxid));
 		PQfinish(conn);
 
 		/* Reset datallowconn flag */
diff --git a/src/bin/pg_upgrade/segresize.c b/src/bin/pg_upgrade/segresize.c
index a933befed9..0f44671290 100644
--- a/src/bin/pg_upgrade/segresize.c
+++ b/src/bin/pg_upgrade/segresize.c
@@ -76,7 +76,7 @@ slru_filename_old(const char *path, int64 segno)
 static char *
 slru_filename_new(const char *path, int64 segno)
 {
-	return psprintf("%s/%012llX", path, (long long) segno);
+	return psprintf("%s/%012" PRIX64, path, segno);
 }
 
 static inline FILE *
@@ -373,8 +373,8 @@ convert_multixact_offsets(const char *old_subdir, const char *new_subdir)
 		oldlen = read_old_segment_page(&oldseg, oldbuf, &is_empty);
 
 		if (oldlen == 0 || is_empty)
-			pg_fatal("cannot read page %lld from segment: %s\n",
-					 (long long) oldseg.pageno,
+			pg_fatal("cannot read page %" PRId64 " from segment: %s\n",
+					 oldseg.pageno,
 					 slru_filename_old(oldseg.dir, oldseg.segno));
 
 		/* Save oldest mxid offset */
@@ -501,8 +501,8 @@ convert_multixact_members(const char *old_subdir, const char *new_subdir,
 		oldlen = read_old_segment_page(&oldseg, oldbuf, &old_is_empty);
 
 		if (oldlen == 0 || old_is_empty)
-			pg_fatal("cannot read page %lld from segment: %s\n",
-					 (long long) oldseg.pageno,
+			pg_fatal("cannot read page %" PRId64 " from segment: %s\n",
+					 oldseg.pageno,
 					 slru_filename_old(oldseg.dir, oldseg.segno));
 
 		ngroups = oldlen / MULTIXACT_MEMBERGROUP_SIZE_OLD;
diff --git a/src/bin/pg_waldump/pg_waldump.c b/src/bin/pg_waldump/pg_waldump.c
index 25fdb6feeb..601dace22e 100644
--- a/src/bin/pg_waldump/pg_waldump.c
+++ b/src/bin/pg_waldump/pg_waldump.c
@@ -555,10 +555,10 @@ XLogDumpDisplayRecord(XLogDumpConfig *config, XLogReaderState *record)
 
 	XLogRecGetLen(record, &rec_len, &fpi_len);
 
-	printf("rmgr: %-11s len (rec/tot): %6u/%6u, tx: %20llu, lsn: %X/%08X, prev %X/%08X, ",
+	printf("rmgr: %-11s len (rec/tot): %6u/%6u, tx: %20" PRIu64 ", lsn: %X/%08X, prev %X/%08X, ",
 		   desc->rm_name,
 		   rec_len, XLogRecGetTotalLen(record),
-		   (unsigned long long) XLogRecGetXid(record),
+		   XLogRecGetXid(record),
 		   LSN_FORMAT_ARGS(record->ReadRecPtr),
 		   LSN_FORMAT_ARGS(xl_prev));
 
@@ -1050,8 +1050,7 @@ main(int argc, char **argv)
 				config.filter_by_fpw = true;
 				break;
 			case 'x':
-				if (sscanf(optarg, "%llu",
-						   (unsigned long long *) &config.filter_by_xid) != 1)
+				if (sscanf(optarg, "%" PRIu64, &config.filter_by_xid) != 1)
 				{
 					pg_log_error("invalid transaction ID specification: \"%s\"",
 								 optarg);
diff --git a/src/include/storage/bufpage.h b/src/include/storage/bufpage.h
index 90f7607e3c..54b0150978 100644
--- a/src/include/storage/bufpage.h
+++ b/src/include/storage/bufpage.h
@@ -570,9 +570,8 @@ NormalTransactionIdToShort(TransactionId base, TransactionId xid, bool multi)
 		ereport(PANIC,
 				(errcode(ERRCODE_INTERNAL_ERROR),
 						errbacktrace(),
-						errmsg("xid %llu does not fit into valid range for base %llu",
-							   (unsigned long long) xid,
-							   (unsigned long long) base)));
+						errmsg("xid %" PRIu64 " does not fit into valid range for base %" PRIu64,
+							   xid, base)));
 #endif
 
 	return (ShortTransactionId) (xid - base);
diff --git a/src/test/modules/xid_wraparound/xid_wraparound.c b/src/test/modules/xid_wraparound/xid_wraparound.c
index 83cb3d3d2c..6678a5bac0 100644
--- a/src/test/modules/xid_wraparound/xid_wraparound.c
+++ b/src/test/modules/xid_wraparound/xid_wraparound.c
@@ -136,13 +136,13 @@ consume_xids_common(FullTransactionId untilxid, uint64 nxids)
 		if (consumed - last_reported_at >= REPORT_INTERVAL)
 		{
 			if (nxids > 0)
-				elog(NOTICE, "consumed %" PRIu64 " / %" PRIu64 " XIDs, latest %llu",
+				elog(NOTICE, "consumed %" PRIu64 " / %" PRIu64 " XIDs, latest %" PRIu64,
 					 consumed, nxids,
-					 (unsigned long long) U64FromFullTransactionId(lastxid));
+					 U64FromFullTransactionId(lastxid));
 			else
-				elog(NOTICE, "consumed up to %llu / %llu",
-					 (unsigned long long) U64FromFullTransactionId(lastxid),
-					 (unsigned long long) U64FromFullTransactionId(untilxid));
+				elog(NOTICE, "consumed up to %" PRIu64 " / %" PRIu64,
+					 U64FromFullTransactionId(lastxid),
+					 U64FromFullTransactionId(untilxid));
 			last_reported_at = consumed;
 		}
 	}
diff --git a/src/test/regress/regress.c b/src/test/regress/regress.c
index 392376e092..faf484320a 100644
--- a/src/test/regress/regress.c
+++ b/src/test/regress/regress.c
@@ -1051,9 +1051,8 @@ CheckNewPage(char *msg, Page page)
 	else if (HeapPageIsDoubleXmax(page))
 		elog(INFO, "%s: page is converted into double xmax format", msg);
 	else
-		elog(ERROR, "%s: converted page has pageSpecial size %u, expected %llu",
-			 msg, size,
-			 (unsigned long long) MAXALIGN(sizeof(HeapPageSpecialData)));
+		elog(ERROR, "%s: converted page has pageSpecial size %u, expected %" PRIu64,
+			 msg, size, MAXALIGN(sizeof(HeapPageSpecialData)));
 }
 
 /*
@@ -1230,14 +1229,12 @@ xid64_test_2(PG_FUNCTION_ARGS)
 		for (i = 0; i != before.ntuples; ++i)
 		{
 			if (before.tcv[i].xmin != after.tcv[i].xmin && after.tcv[i].xmin)
-				elog(ERROR, "old and new xmin does not match (%llu != %llu)",
-					 (unsigned long long) before.tcv[i].xmin,
-					 (unsigned long long) after.tcv[i].xmin);
+				elog(ERROR, "old and new xmin does not match (%" PRIu64 " != %" PRIu64 ")",
+					 before.tcv[i].xmin, after.tcv[i].xmin);
 
 			if (before.tcv[i].xmax != after.tcv[i].xmax)
-				elog(ERROR, "old and new xmax does not match (%llu != %llu)",
-					 (unsigned long long) before.tcv[i].xmax,
-					 (unsigned long long) after.tcv[i].xmax);
+				elog(ERROR, "old and new xmax does not match (%" PRIu64 " != %" PRIu64 ")",
+					 before.tcv[i].xmax, after.tcv[i].xmax);
 		}
 
 		Assert(npages != 0);
-- 
2.49.0

